function ABCom() {}
ABCom.ServerRunning  = true;
ABCom.PollingEnabled = true;

ABCom.INTERCEPT=true;
ABCom.MONITOR_LOOP_INTERVAL = 1000;
ABCom.STOPPED_POLL_INTERVAL = 2000;
ABCom.RUNNING_POLL_INTERVAL = 6000;

ABCom.initialized=false;
ABCom.lastactivity=0;
ABCom.DEBUG=false;

//------ SERVER RUNNING/STOPPED --------------
ABCom.system_monitor_properties=null;
ABCom.system_monitor_id=null;
ABCom.activeMonitor=false;
ABCom._blockedResources=new Array();

ABCom.init = function (properties, activeMonitor) {
   if (ABCom.initialized) return;
   ABCom.initialized=true;
   
   ABCom.ServerRunning  = true;
   ABCom.PollingEnabled = true;
   ABCom.activeMonitor=false;
   ABCom.tasks = {};
   ABCom.system_monitor_id=null;
   ABCom.system_monitor_properties=null;
   if ( arguments.length > 0                               &&
        (typeof properties     == "object")                &&
        (typeof properties.url == "string")                &&
        properties.url.length > 0                          &&
        (typeof properties.callbackStopped == "function")  &&
        (typeof properties.callbackRunning == "function"))
     {
        ABCom.system_monitor_properties={};
        // ABCom.system_monitor_properties=properties;
        ABCom.system_monitor_properties.url             = properties.url;
        ABCom.system_monitor_properties.callbackStopped = properties.callbackStopped;
        ABCom.system_monitor_properties.callbackRunning = properties.callbackRunning;
     }
//   else
//     return false;

   ABCom._blockedResources=new Array();

   ABCom._io_area_={};
   ABCom._io_area_.xhrGet     = dojo.xhrGet;
   ABCom._io_area_.xhrPut     = dojo.xhrPut;
   ABCom._io_area_.xhrPost    = dojo.xhrPost;
   ABCom._io_area_.xhrDelete  = dojo.xhrDelete;
   ABCom._io_area_.rawXhrPut  = dojo.rawXhrPut;
   ABCom._io_area_.rawXhrPost = dojo.rawXhrPost;

   if (ABCom.INTERCEPT) {
      dojo.xhrGet     = ABCom.xhrGet;
      dojo.xhrPut     = ABCom.xhrPut;
      dojo.xhrPost    = ABCom.xhrPost;
      dojo.xhrDelete  = ABCom.xhrDelete;
      dojo.rawXhrPut  = ABCom.rawXhrPut;
      dojo.rawXhrPost = ABCom.rawXhrPost;
   }
   
   if (typeof ABCom.system_monitor_properties == "object") {
     if (arguments.length > 1 && (typeof activeMonitor == "boolean") && (activeMonitor)) {
    	 ABCom.activeMonitor=true;
   	 }
     ABCom.system_monitor_id = setInterval(ABCom._monitor, ABCom.MONITOR_LOOP_INTERVAL);
   }
}
ABCom.schedule=function (taskname, fn, args, interval, fnUrl) {
  if (!ABCom.initialized || (typeof ABCom.system_monitor_properties != "object")) return;
  if (typeof taskname == "string"            &&
      taskname.length > 0                    &&
      typeof ABCom.tasks[taskname] == "undefined"  &&
      typeof fn  == "function"               &&
      ( fn===ABCom.xhrGet     || fn===dojo.xhrGet      ||
        fn===ABCom.xhrPut     || fn===dojo.xhrPut      ||
        fn===ABCom.xhrPost    || fn===dojo.xhrPost     ||
        fn===ABCom.xhrDelete  || fn===dojo.xhrDelete   ||
        fn===ABCom.rawXhrPut  || fn===dojo.rawXhrPut   ||
        fn===ABCom.rawXhrPost || fn===dojo.rawXhrPost)
      )
       {
              if (fn===dojo.xhrGet)     fn=ABCom.xhrGet;
         else if (fn===dojo.xhrPut)     fn=ABCom.xhrPut;
         else if (fn===dojo.xhrPost)    fn=ABCom.xhrPost;
         else if (fn===dojo.xhrDelete)  fn=ABCom.xhrDelete;
         else if (fn===dojo.rawXhrPut)  fn=ABCom.rawXhrPut;
         else if (fn===dojo.rawXhrPost) fn=ABCom.rawXhrPost;          
 
         var url="";
         if (arguments.length <= 4 || (typeof fnUrl != "function"))
           {
             fnUrl=null;
           }
         else
           {
             if (typeof args.url == "string")
               url=args.url;
           }

         args._ab_task_id_=taskname;   // Scheduled Events Have Names that must be kept
         var task = {
           suspended:    false,
           loop:         0,
           fn:           fn,
           fnUrl:        fnUrl,
           url:          url,
           args:         args,
           interval:     interval,
           lastreq:      0,
           lastresp:     0
         }
         ABCom.tasks[args._ab_task_id_]=task;
         return true;
       }
  else
    return false;
}
ABCom.isPollingSuspended = function() {
  return (!ABCom.PollingEnabled);
}
ABCom.suspendPolling = function() {
  ABCom.PollingEnabled=false;
}
ABCom.resumePolling = function() {
  ABCom.PollingEnabled=true;
}
ABCom.suspendTask = function(task_id) {
  if (typeof task_id == "string"            &&
      task_id.length > 0                    &&
      (typeof ABCom.tasks[task_id] == "object") )
   {
     ABCom.tasks[task_id].suspended=true;
   }
}
ABCom.resumeTask  = function(task_id) {
  if (typeof task_id == "string"            &&
      task_id.length > 0                    &&
      (typeof ABCom.tasks[task_id] == "object") )
   {
     ABCom.tasks[task_id].suspended=false;
   }
}
ABCom.isURLBlocked = function(url) {
  if (typeof url == "string"            &&
      url.length > 0)
   {
     for (var i=0; i<ABCom._blockedResources.length; i++)
       {
         if (url.indexOf(ABCom._blockedResources[i]) >= 0)
            return true;
       }
     return false;
   }
}
ABCom.isResourceBlocked = function(resource) {
  if (typeof resource == "string"            &&
      resource.length > 0)
   {
     for (var i=0; i<ABCom._blockedResources.length; i++)
       {
         if (ABCom._blockedResources[i]==resource)
            return true;
       }
     return false;
   }
}
ABCom.blockResource = function(resource) {
  if (typeof resource == "string"            &&
      resource.length > 0                    &&
      !ABCom.isResourceBlocked(resource))
   {
     ABCom._blockedResources.push(resource);
     return;
   }
}
ABCom.unblockResource = function(resource) {
  if (typeof resource == "string"            &&
      resource.length > 0)
   {
     for (var i=0; i<ABCom._blockedResources.length; i++)
       {
         if (ABCom._blockedResources[i]==resource) {
            delete ABCom._blockedResources[i];
            return;
         }
       }
   }
}
ABCom.server_stopped = function() {
  if (ABCom.ServerRunning) {
     ABCom.ServerRunning=false;
     if ((typeof ABCom.system_monitor_properties == "object") && typeof ABCom.system_monitor_properties.callbackStopped=="function") {
       var f = function() {ABCom.system_monitor_properties.callbackStopped();};
       f();
     }
  }
}
ABCom.server_running = function() {
  if (!ABCom.ServerRunning) {
     ABCom.ServerRunning=true;
     if ((typeof ABCom.system_monitor_properties == "object") && typeof ABCom.system_monitor_properties.callbackStopped=="function") {
       var f = function() {ABCom.system_monitor_properties.callbackRunning();};
       f();
     }
  }
}
ABCom.xhrGet  = function (args) {
  return ABCom._xhrInvoke(ABCom._io_area_.xhrGet, args);
}
ABCom.xhrPut  = function (args) {
  return ABCom._xhrInvoke(ABCom._io_area_.xhrPut, args);
}
ABCom.xhrPost = function (args) {
  return ABCom._xhrInvoke(ABCom._io_area_.xhrPost, args);
}
ABCom.xhrDelete = function (args) {
  return ABCom._xhrInvoke(ABCom._io_area_.xhrDelete, args);
}
ABCom.rawXhrPut  = function (args) {
  return ABCom._xhrInvoke(ABCom._io_area_.rawXhrPut, args);
}
ABCom.rawXhrPost = function (args) {
  return ABCom._xhrInvoke(ABCom._io_area_.rawXhrPost, args);
}
ABCom._xhrInvoke = function (fn, args) {
  if (typeof args == "object"            &&
      typeof args.url == "string"        &&
      !ABCom.isURLBlocked(args.url)      &&
      ( fn===ABCom._io_area_.xhrGet    ||
        fn===ABCom._io_area_.xhrPut    ||
        fn===ABCom._io_area_.xhrPost   ||
        fn===ABCom._io_area_.xhrDelete ||
        fn===ABCom._io_area_.rawXhrPut ||
        fn===ABCom._io_area_.rawXhrPost)
      )
    {
       if (typeof args._ab_data_area_ == "undefined") {
          args._ab_data_area_={};
          if (typeof args.load   == "function") {
              if (typeof args._ab_data_area_.load == "undefined") {
                 args._ab_data_area_.load=args.load;
              }
              args.load=ABCom._callback_load;
          }
          if (typeof args.error  == "function") {
              if (typeof args._ab_data_area_.error == "undefined") {
                 args._ab_data_area_.error=args.error;
              }
              args.error=ABCom._callback_error;
          }
          if (typeof args.handle == "function") {
              if (typeof args._ab_data_area_.handle == "undefined") {
                 args._ab_data_area_.handle=args.handle;
              }
              args.handle=ABCom._callback_handle;
          }
       }
    }
  else
    return;

  if (!ABCom.ServerRunning)
    return;

  ABCom.lastactivity=new Date().getTime();
  return fn(args);
}
ABCom._callback_load   = function(resp, ioargs) {
  ABCom._callback(1, resp, ioargs);
}
ABCom._callback_error  = function(resp, ioargs) {
  ABCom._callback(2, resp, ioargs);
}
ABCom._callback_handle = function(resp, ioargs) {
  ABCom._callback(3, resp, ioargs);
}
ABCom._callback = function(type, resp, ioargs) {
   ABCom.lastactivity=new Date().getTime();
   if (typeof ioargs.args == "object" &&  (typeof ioargs.args._ab_task_id_ == "string")) {
     if (typeof ABCom.tasks[ioargs.args._ab_task_id_] == "object") {
       var tm=new Date().getTime();
       ABCom.tasks[ioargs.args._ab_task_id_].lastresp=tm;
     }
   }

   if (ioargs.xhr.status == 0 || ioargs.xhr.status == 12029) {
     ABCom.server_stopped();
   }
   else
   if (!ABCom.ServerRunning) {
     ABCom.server_running();
   }

   if (ABCom.ServerRunning)
     {
       if (typeof ioargs.args == "object")
         {
           var args=ioargs.args;
           var cb=null;
           if (type==1 && !(typeof args._ab_data_area_.load   == "undefined"))
             cb=args._ab_data_area_.load;
           else
           if (type==2 && !(typeof args._ab_data_area_.error  == "undefined"))
             cb=args._ab_data_area_.error;
           else
           if (type==3 && !(typeof args._ab_data_area_.handle == "undefined"))
             cb=args._ab_data_area_.handle;

           if (cb!=null)
             {
               cb(resp, ioargs);
             }
         }
     }
}
ABCom._monitor = function () {
  if (!ABCom.ServerRunning)
    {
      var tm=new Date().getTime();
      if (tm-ABCom.lastactivity > ABCom.STOPPED_POLL_INTERVAL)
        {
          ABCom.lastactivity=tm;
          ABCom._io_area_.xhrGet({
                  url:   ABCom.system_monitor_properties.url,
                  load:  function(response, ioargs) {
                           ABCom.lastactivity=new Date().getTime();
                           if (!(ioargs.xhr.status == 0 || ioargs.xhr.status == 12029)) {
                               ABCom.server_running();
                           }
                           return response;
                         },
                  error: function(response, ioargs) {
                           ABCom.lastactivity=new Date().getTime();
                           if (!(ioargs.xhr.status == 0 || ioargs.xhr.status == 12029)) {
                               ABCom.server_running();
                           }
                           return response;
                         },
                  handleAs: "text"
                });
        }
      return;
    }

  if (!ABCom.PollingEnabled) return;

  //----------- Run Any Scheduled Tasks whose Time has Come
  var tasksrun=0;
  var next_scheduled_event=0;
  for (var task_id in ABCom.tasks) {
    var task=ABCom.tasks[task_id];
    if (task.suspended || (task.lastreq>task.lastresp)) {
      // Task Suspended OR A Request Pending
    }
    else {
      var tm=new Date().getTime();
      if ((tm - task.lastresp) > task.interval)
        {
          tasksrun++;
          task.lastreq=tm;
          var url="";
          if (task.fnUrl != null)
            {
              var temp = task.fnUrl();
              if (typeof temp == "string")
                url=temp;
            }
          else
          if (typeof task.url == "string")
              url=task.url;
          
          var args=task.args;
          if (url.length>0) {
            args.url=url;
          }
               
          if (ABCom.DEBUG) {
        	  if (url.length>0) {
         	 	var date=new Date();
        	  	var hr=date.getHours();
        	  	if (hr<10) hr="0"+hr;
        	 	var mn=date.getMinutes();
        	 	if (mn<10) hr="0"+mn;
         	 	var sc=date.getSeconds();
        	 	if (sc<10) sc="0"+sc;
         		var ms=date.getMilliseconds();
        	 	if (ms<10) ms="00"+ms;
        	 	else if (ms<100) ms="0"+ms;
          		var tm=hr+":"+mn+":"+sc+"."+ms;
          		if (url.indexOf("?")>0)
					args.url=url+"&tm="+tm;
  			  	else
					args.url=url+"?tm="+tm;
   			  }
   		  }
   		  
          var invoker=function() {task.fn(args);};
          invoker();
        }
      else
        {
          if ((next_scheduled_event==0 || ((task.lastresp+task.interval) < next_scheduled_event))) {
            next_scheduled_event = task.lastresp+task.interval;
          }
        }
    }
  }
  if (tasksrun > 0)
    return;

  if (!ABCom.activeMonitor) return;

  var tm=new Date().getTime();
  if (   tm-ABCom.lastactivity > ABCom.RUNNING_POLL_INTERVAL
         && ((next_scheduled_event==0) || tm + parseInt(ABCom.RUNNING_POLL_INTERVAL/2) < next_scheduled_event)
     )
   {
     ABCom.lastactivity=new Date().getTime();
     ABCom._io_area_.xhrGet({
             url:    ABCom.system_monitor_properties.url,
             load:   function(response, ioargs) {
                       ABCom.lastactivity=new Date().getTime();
                       if (ioargs.xhr.status == 0 || ioargs.xhr.status == 12029) {
                         ABCom.server_stopped();
                       }
                       return response;
                     },
             error:  function(response, ioargs) {
                       ABCom.lastactivity=new Date().getTime();
                       if (ioargs.xhr.status == 0 || ioargs.xhr.status == 12029) {
                         ABCom.server_stopped();
                       }
                       return response;
                     },
             handleAs: "text"
           });
   }
}